<?php

//
// Copyright (C) 2013, 2014 FromDual GmbH
//
// This program is commercial software. Use of this software is governed
// by your applicable license agreement with FromDual GmbH
//

require_once('lib/Cluster.inc');

// ---------------------------------------------------------------------
if ( $hType == 'replication' ) {
// ---------------------------------------------------------------------

  $aCluster = array();

  // print "<pre>"; print_r($_REQUEST); print "</pre>\n";

  // Parse parameter
  $aCluster['cluster_id'] = isset($_REQUEST['cluster_id']) ? intval($_REQUEST['cluster_id']) : 0;
  $aCluster['name']       = isset($_REQUEST['name']) ? substr(strval($_REQUEST['name']), 0, 32) : '';
  $aCluster['type']       = isset($_REQUEST['type']) ? intval($_REQUEST['type']) : 0;
//   $aCluster['vip']        = isset($_REQUEST['vip']) ? substr(strval($_REQUEST['vip']), 0, 16) : '';
  // print "<pre>"; print_r($aCluster); print "</pre>\n";

  $aMasters = $_REQUEST['master_id'];
  $aSlaves  = $_REQUEST['slave_id'];

  // print "<pre>"; print_r($aMasters); print "</pre>\n";
  // print "<pre>"; print_r($aSlaves); print "</pre>\n";

  // Remove entries which were not set
  foreach ( $aMasters as $node_id ) {
    if ( $node_id == 0 ) {
      array_pop($aMasters);
    }
  }

  // Remove entries which were not set
  foreach ( $aSlaves as $node_id ) {
    if ( $node_id == 0 ) {
      array_pop($aSlaves);
    }
  }
  // print "<pre>"; print_r($aMasters); print "</pre>\n";
  // print "<pre>"; print_r($aSlaves); print "</pre>\n";

  print "<h1>Safe Replication</h1>\n";

  // We have 2 cased:
  // a) Cluster exists yet -> its a update
  // b) Cluster does not exits --> its a insert

  list($rc, $dbh) = openRepositoryDatabase();

  // Check if Cluster name already exists
  list($rc, $a) = getClusterByName($dbh, $aCluster['name']);
  if ( $rc != 0 ) {
    $rc = 121;
    print "<p>Error: Cluster name already exists (rc=$rc)</p>\n";
    exit($rc);
  }

  // 1 = M/S, 2 = M/M
  if ( ($aCluster['type'] != 1) && ($aCluster['type'] != 2) ) {
    print "<p>Cluster type must be 1 or 2 but is " . $aCluster['type'] . ". I will fix this now for you...</p>\n";
    $aCluster['type'] = 1;
  }

  // Check if Master is already involved somewhere else
  foreach ( $aMasters as $node_id ) {

    $ret = isDatabaseInOtherCluster($dbh, $node_id, $aCluster['cluster_id']);
    if ( $ret === true ) {
      $rc = 120;
      print "<p>Master (node_id=$node_id) is already in use somewhere else. Please check an fix this (rc=$rc).</p>\n";
    }
  }

  // Check if Slave is already involved somewhere else
  foreach ( $aSlaves as $node_id ) {
    $ret = isDatabaseInOtherCluster($dbh, $node_id, $aCluster['cluster_id']);
    if ( $ret === true ) {
      $rc = 122;
      print "<p>Slave (node_id=$node_id) is already in use somewhere else. Please check an fix this (rc=$rc).</p>\n";
    }
  }

  // // Check VIP
  // if ( $aCluster['vip'] != '' ) {
  //
  //   list($rc, $a) = getVipByIp($dbh, $aCluster['vip']);
  //   // VIP already exists
  //   if ( count($a) > 0 ) {
  //     print "<p>VIP $vip already exists. Please check an fix this.</p>\n";
  //   }
  //   // VIP does not exists yet
  //   else {
  //     if ( $ret === true ) {
  //       $rc = 128;
  //       print "<p>VIP $vip is already in use somewhere else. Please check an fix this.</p>\n";
  //     }
  //   }
  // }

  if ( $rc != 0 ) {
    print "<p><input type='button' value='Back' onclick='window.history.back();'></p>\n";
    exit($rc);
  }

  // Cluster exists
  if ( $aCluster['cluster_id'] != 0 ) {

    // Check if cluster name exits and it is not ours
    if ( (count($a) > 0) && ($a['cluster_id'] != $aCluster['cluster_id']) ) {
      $rc = 127;
      print "<p>Cluster name already exists (rc=$rc)</p>";
      exit($rc);
    }

    // Write Cluster down
    $rc = updateCluster($dbh, $aCluster);

    // Delete all Cluster/Node relations in case we want to delete one
    // node from cluster
    list($rc, $cnt) = deleteAllNodesFromCluster($dbh, $aCluster['cluster_id']);

    // Write Master relation down
    foreach ( $aMasters as $node_id ) {
      $rc = addMasterToCluster($dbh, $aCluster['cluster_id'], $node_id);
    }

    // Write Slave relation down
    // There is at least one Slave specified
    // print "<pre>"; print_r($aMasters); print "</pre>\n";
    // print "<pre>"; print_r($aSlaves); print "</pre>\n";
    if ( isset($aSlaves) ) {

      foreach ( $aSlaves as $node_id ) {
        $rc = addSlaveToCluster($dbh, $aCluster['cluster_id'], $node_id);
      }
    }
    // There is NO Slave specified
    else {

      // This is OK if M/M is specified
      if ( $aCluster['type'] == 2 ) {
        print "<p>No Slave specifed. This is OK for Master/Master Replication.</p>\n";
      }
      // This is NOT OK if M/S is specified
      else {
        print "<p>No Slave specifed. This is NOT OK for Master/Slave Replication. Please fix this later...</p>\n";
      }
    }

    // // Write VIP relation down
    // list($rc, $lVipId) = addVip($dbh, $aCluster['vip']);

    print "<p>Cluster altered.</p>\n";
  }
  // Cluster is new
  else {

    // Check if cluster name already exits
    if ( count($a) > 0 ) {
      $rc = 129;
      print "<p>Cluster name already exists (rc=$rc)</p>\n";
      exit($rc);
    }

    // Write Cluster down
    list($rc, $lClusterId) = addCluster($dbh, $aCluster);

    // Write Master relation down
    foreach ( $aMasters as $node_id ) {
      $rc = addMasterToCluster($dbh, $lClusterId, $node_id);
    }

    // Write Slave relation down
    foreach ( $aSlaves as $node_id ) {
      $rc = addSlaveToCluster($dbh, $lClusterId, $node_id);
    }

    // // Write VIP relation down
    // list($rc, $lVipId) = addVip($dbh, $aCluster['vip']);

    print "<p>Cluster created.</p>\n";
  }

  closeRepositoryDatabase($dbh);
  print "<p><input type='button' value='Continue' onclick='location.href=" . '"index.php?f=show&amp;o=replication&amp;s=overview"' . ";' /></p>\n";
}
// ---------------------------------------------------------------------
elseif ( $hType == 'node' )
// ---------------------------------------------------------------------
{
  print "<pre>"; print_r($_REQUEST); print "</pre>\n";

  $aNode = array();

  // Parse parameter

  $aCluster['cluster_id'] = isset($_REQUEST['cluster_id']) ? intval($_REQUEST['cluster_id']) : 0;
  $aCluster['type']       = isset($_REQUEST['type']) ? intval($_REQUEST['type']) : 0;

  $aSlave['node_id']      = isset($_REQUEST['node_id']) ? intval($_REQUEST['node_id']) : 0;
  $role                   = isset($_REQUEST['role']) ? substr(strval($_REQUEST['role']), 0, 8) : '';
  if ( $role == 'Slave' ) {
    $aSlave['role_id'] = 2;
  }

  print "Saving node...";

  list($rc, $dbh) = openRepositoryDatabase();
  $rc = addSlaveToCluster($dbh, $aCluster['cluster_id'], $aSlave['node_id']);
  closeRepositoryDatabase($dbh);
  ?>
  <p><input type="button" value="Continue" onclick="location.href='index.php?f=show&amp;o=replication&amp;s=configuration&amp;cluster_id=<?php print $aCluster['cluster_id']; ?>'" /></p>
  <?php
}
// ---------------------------------------------------------------------
else {
// ---------------------------------------------------------------------
  print "Unknown type $hType\n";
}

?>
