<?php

//
// Copyright (C) 2013, 2014 FromDual GmbH
//
// This program is commercial software. Use of this software is governed
// by your applicable license agreement with FromDual GmbH
//

// print "<pre>"; print_r($_REQUEST); print "</pre>";

list($rc, $dbh) = openRepositoryDatabase();
list($rc, $aDatabase) = getNodesOfClusterById($dbh, $hClusterId);
list($rc, $aCluster) = getClusterById($dbh, $hClusterId);

?>

<h2>Operations</h2>

<h3>Master</h3>

<table border="1" cellpadding="3" cellspacing="0">
  <tr>
    <th align="left">Database</th>
    <th>Server</th>
    <th>rw/ro</th>
    <!-- <th></th> -->
    <th>Node</th>
  </tr>
  <?php

  // print "<pre>"; print_r($aDatabase); print "</pre>";
  foreach ( $aDatabase as $node_id => $node ) {

    if ( $node['role_id'] == SLAVE ) {
      continue;
    }

    ?>
    <tr>
      <td><a href='index.php?f=show&amp;o=node&amp;s=configuration&amp;node_id=<?php print $node['node_id']; ?>'><?php print $node['name']; ?></a></td>
      <?php

      list($rc, $aServer) = getServerById($dbh, $node['server_id']);
      if ( count($aServer) == 0 ) { $aServer['name'] = ''; }
        ?>
        <td><?php print $aServer['name']; ?></td>
        <?php

    // rw/ro

    $color = 'black';

    // Master is ALWAYS bad if read_only
    // Caution: We check the wrong value here. We check the configuration.
    // Not what is currently set on the server...
    // Role id 1: Master
    if ( ($node['role_id'] == 1) && ($node['read_only'] == 1) ) {
      $color = 'red';
    }
    // Role id 2: Slave
    if ( $node['role_id'] == 2 ) {

      list($rc, $aDatabaseCheck) = getDatabaseCheck($dbh, $node['node_id'], 'mysqld', 'read_only');
      // print "<pre>"; print_r($aDatabaseCheck); print "</pre>";
      $color = '';
      if ( count($aDatabaseCheck) == 0 ) {
        $color = 'orange';
      }
      else {
        if ( $aDatabaseCheck['last_check_status'] == 'ERR' ) {
          $color = 'red';
        }
        else {
          $color = 'green';
        }
      }
    }

    // todo: This is wrong: we want what is set and not what is wanted in configuration?
    if ( $node['read_only'] == 1 ) {
      $val = 'ro';
    }
    else {
      $val = 'rw';
    }

    print "  <td align='center'><span style='color:" . $color . ";'>" . $val . "</span></td>\n";

    // Start/Stop Slave

    // We only need status of Slave for now
    // Role id 2: Slave
    if ( $node['role_id'] == 2 ) {

      list($rc, $mysqli) = openDatabaseConnection($node['database_user'], $node['database_user_password'], $node['hostname'], $node['port']);

      if ( $rc != 0 ) {
        $rc = 997;
//         print "<p>ERROR: $mysqli, database: " . $node['name'] . ", connect information: " . $node['database_user'] . '@' . $node['hostname'] . ':' . $node['port'] . " (rc=$rc).</p>\n";
        $aSlaveStatus = array();
      }
      else {

        list($rc, $aSlaveStatus) = getShowSlaveStatus($mysqli);
        // print "<pre>"; print_r($aSlaveStatus); print "</pre>";
        closeDatabaseConnection($mysqli);
      }
    }
    ?><!-- <td><button onClick="" disabled="disabled">Rest Master</button></td> --><?php

    // print "  <td align='center'><input type='button', name='stop' disabled='disabled' value='Reset " . $node['role_id']  . "'></td>\n";

    // Node status
    // todo: make sure that this is live data and not from the past!

    $ret = getCheckSummaryById($node['node_id']);
    switch ( $ret ) {
    case 0:
      $color = 'green';
      $msg   = 'OK';
      break;
    case 1:
      $color = 'orange';
      $msg   = 'WRN';
      break;
    case 2:
      $color = 'red';
      $msg   = 'ERR';
      break;
    case 9:
      $color = 'orange';
      $msg   = 'UNK';
      break;
    default:
      $color = 'red';
      $msg   = 'UNK';
    };

    ?><td align="center"><span style="color:'<?php print $color; ?>';"><strong><?php print $msg; ?></strong></span></td><?php

    // Replication status

    ?></tr><?php
  }
  ?>
</table>

<script>

$(function() {

  $( "#hourglass" ).dialog( 'close' );
});

</script>

<?php

list($rc, $aNodes) = getNodesOfClusterById($dbh, $hClusterId);

?>

<h3>Slaves</h3>

<table border="1" cellpadding="3" cellspacing="0">
  <tr>
    <th align="left">Database</th>
    <th>Server</th>
    <th>rw/ro</th>
    <th>Node</th>
    <th>Replication</th>
  </tr>
  <?php

  // print "<pre>"; print_r($aDatabase); print "</pre>";
  foreach ( $aDatabase as $node_id => $node ) {

    if ( $node['role_id'] == MASTER ) {
      continue;
    }

    ?>
    <tr>
      <td><a href="index.php?f=show&amp;o=node&amp;s=configuration&amp;node_id=<?php print $node['node_id']; ?>"><?php print $node['name']; ?></a></td>
      <?php

      list($rc, $aServer) = getServerById($dbh, $node['server_id']);
      if ( count($aServer) == 0 ) { $aServer['name'] = ''; }
      print "  <td>" . $aServer['name'] . "</td>\n";

      // rw/ro

      $color = 'black';

      // Master is ALWAYS bad if read_only
      // Caution: We check the wrong value here. We check the configuration.
      // Not what is currently set on the server...
      // Role id 1: Master
      if ( ($node['role_id'] == 1) && ($node['read_only'] == 1) ) {
        $color = 'red';
      }
      // Role id 2: Slave
      if ( $node['role_id'] == 2 ) {

        list($rc, $aDatabaseCheck) = getDatabaseCheck($dbh, $node['node_id'], 'mysqld', 'read_only');
        // print "<pre>"; print_r($aDatabaseCheck); print "</pre>";
        $color = '';
        if ( count($aDatabaseCheck) == 0 ) {
          $color = 'orange';
        }
        else {
          if ( $aDatabaseCheck['last_check_status'] == 'ERR' ) {
            $color = 'red';
          }
          else {
            $color = 'green';
          }
        }
      }

      // todo: This is wrong: we want what is set and not what is wanted in configuration?
      if ( $node['read_only'] == 1 ) {
        $val = 'ro';
      }
      else {
        $val = 'rw';
      }

      print "  <td align='center'><span style='color:" . $color . ";'>" . $val . "</span></td>\n";

    // Start/Stop Slave

    // We only need status of Slave for now
    // Role id 2: Slave
    if ( $node['role_id'] == 2 ) {

      list($rc, $mysqli) = openDatabaseConnection($node['database_user'], $node['database_user_password'], $node['hostname'], $node['port']);

      if ( $rc != 0 ) {
        $rc = 996;
//         print "<p>ERROR: $mysqli, database: " . $node['name'] . ", connect information: " . $node['database_user'] . '@' . $node['hostname'] . ':' . $node['port'] . " (rc=$rc).</p>\n";
        $aSlaveStatus = array();
      }
      else {

        list($rc, $aSlaveStatus) = getShowSlaveStatus($mysqli);
        // print "<pre>"; print_r($aSlaveStatus); print "</pre>";
        closeDatabaseConnection($mysqli);
      }
    }


    // print "  <td align='center'><input type='button', name='stop' disabled='disabled' value='Reset " . $node['role_id']  . "'></td>\n";

    // Node status
    // todo: make sure that this is live data and not from the past!

    $ret = getCheckSummaryById($node['node_id']);
    switch ( $ret ) {
    case 0:
      $color = 'green';
      $msg   = 'OK';
      break;
    case 1:
      $color = 'orange';
      $msg   = 'WRN';
      break;
    case 2:
      $color = 'red';
      $msg   = 'ERR';
      break;
    case 9:
      $color = 'orange';
      $msg   = 'UNK';
      break;
    default:
      $color = 'red';
      $msg   = 'UNK';
    };

    print "  <td align='center'><span style='color:" . $color . ";'><strong>" . $msg . "</strong></span></td>\n";


    // Replication status

    // Role id 1: Master
    if ( $node['role_id'] == 1 ) {
      print "  <td>&nbsp;</td>\n";
    }
    else {

      list($rc, $mysqli) = openDatabaseConnection($node['database_user'], $node['database_user_password'], $node['hostname'], $node['port']);
      if ( $rc != 0 ) {
        $rc = 768;
//         print "<p>Open database " . $node['name'] . " failed (rc=$rc).</p>\n";
        $aSlaveStatus = array();
      }
      else {
        list($rc, $aSlaveStatus) = getShowSlaveStatus($mysqli);
        closeDatabaseConnection($mysqli);
      }

      // This is NO Slave yet
      if ( count($aSlaveStatus) == 0 ) {
        $color = 'red';
        $msg   = 'ERR';
      }
      // This is a Slave
      else {

        // Slave is running
        if ( ($aSlaveStatus['Slave_IO_Running'] == 'Yes') && ($aSlaveStatus['Slave_SQL_Running'] == 'Yes') ) {
          $color = 'green';
          $msg   = 'OK';
        }
        // Slave has any problem
        else {
          $color = 'red';
          $msg   = 'ERR';
        }
      }
      print "  <td align='center'><span style='color:" . $color . ";'><strong>" . $msg . "</strong></span></td>\n";
    }
    ?>
    </tr>
    <tr>
      <td></td>
      <td colspan="4">
      <?php

      list($ret, $mysqli) = openDatabaseConnection($node['database_user'], $node['database_user_password'], $node['hostname'], $node['port']);
      if ( $ret != 0 ) {
        print "<p>" . $mysqli . "</p>\n";
        exit($ret);
      }

      list($ret, $aGlobalVariables) = getAllGlobalVariables($mysqli);
      // print "<pre>"; var_dump($aGlobalVariables); print "</pre>";
      // list($ret, $aMasterStatus) = getShowMasterStatus($mysqli);
      // print "<pre>"; var_dump($aMasterStatus); print "</pre>";
      list($ret, $aSlaveStatus) = getShowSlaveStatus($mysqli);
      // print "<pre>"; var_dump($aSlaveStatus); print "</pre>";
      closeDatabaseConnection($mysqli);

      // Never disable this key because even if both threads are set to
      // NO we need to stop slave for CHANGE MASTER command!
      $js = 'window.location="index.php?f=stop&amp;o=slave&amp;node_id=' . $node['node_id'] . '";';
      ?>
      <input type="button" value="Stop Slave" onClick='<?php print $js; ?>'>

      &nbsp;

      <?php
      $disabled = '';
      if ( $aSlaveStatus['Slave_IO_Running'] == 'No' ) {
        $disabled = ' disabled="disabled"';
      }
      $js = 'window.location="index.php?f=stop&amp;o=slave&amp;t=io_thread&amp;node_id=' . $node['node_id'] . '";';
      ?>
      <input type="button" value="Stop IO Thread" <?php print $disabled; ?> onClick='<?php print $js; ?>'>

      &nbsp;

      <?php
      $disabled = '';
      if ( $aSlaveStatus['Slave_SQL_Running'] == 'No' ) {
        $disabled = ' disabled="disabled"';
      }
      $js = 'window.location="index.php?f=stop&amp;o=slave&amp;t=sql_thread&amp;node_id=' . $node['node_id'] . '";';
      ?>
      <input type="button" value="Stop SQL Thread" <?php print $disabled; ?> onClick='<?php print $js; ?>'>

      <br />

      <?php
      $disabled = '';
      if ( ($aSlaveStatus['Slave_IO_Running'] == 'Yes') && ($aSlaveStatus['Slave_IO_Running'] == 'Yes') ) {
        $disabled = ' disabled="disabled"';
      }
      $js = 'window.location="index.php?f=start&amp;o=slave&amp;node_id=' . $node['node_id'] . '";';
      ?>
      <input type="button" value="Start Slave" <?php print $disabled; ?> onClick='<?php print $js; ?>'>

      &nbsp;

      <?php
      $disabled = '';
      if ( $aSlaveStatus['Slave_IO_Running'] == 'Yes' ) {
        $disabled = ' disabled="disabled"';
      }
      $js = 'window.location="index.php?f=start&amp;o=slave&amp;t=io_thread&amp;node_id=' . $node['node_id'] . '";';
      ?>
      <input type="button" value="Start IO Thread" <?php print $disabled; ?> onClick='<?php print $js; ?>'>

      &nbsp;

      <?php
      $disabled = '';
      if ( $aSlaveStatus['Slave_SQL_Running'] == 'Yes' ) {
        $disabled = ' disabled="disabled"';
      }
      $js = 'window.location="index.php?f=start&amp;o=slave&amp;t=sql_thread&amp;node_id=' . $node['node_id'] . '";';
      ?>
      <input type="button" value="Start SQL Thread" <?php print $disabled; ?> onClick='<?php print $js; ?>'>

      <br />

      <?php
      $js = 'window.location="index.php?f=skip&amp;o=slave&amp;t=event&amp;node_id=' . $node['node_id'] . '";';
      ?>
      <input type="button" value="Skip 1 event" onClick='<?php print $js; ?>'>

      &nbsp;

      <?php
      $disabled = '';
      if ( ($aSlaveStatus['Slave_IO_Running'] == 'Yes') || ($aSlaveStatus['Slave_IO_Running'] == 'Yes') ) {
        $disabled = ' disabled="disabled"';
      }
      $js = 'window.location="index.php?f=reset&amp;o=slave&amp;node_id=' . $node['node_id'] . '";';
      ?>
      <input type="button" value="Reset Slave" title="Slave can only be reset when stopped." <?php print $disabled; ?> onClick='<?php print $js; ?>'>

      &nbsp;

      <?php
      $disabled = '';
      if ( ($aSlaveStatus['Slave_IO_Running'] == 'Yes') || ($aSlaveStatus['Slave_IO_Running'] == 'Yes') ) {
        $disabled = ' disabled="disabled"';
      }
      $js = 'window.location="index.php?f=show&amp;o=slave&amp;t=build&amp;node_id=' . $node['node_id'] . '";';
      ?>
      <input type="button" value="Build Slave" title="Slave can only be built when stopped." <?php print $disabled; ?> onClick='<?php print $js; ?>'>

      &nbsp;

      <?php
      $disabled = '';
      if ( ($aSlaveStatus['Slave_IO_Running'] == 'Yes') || ($aSlaveStatus['Slave_IO_Running'] == 'Yes') ) {
        $disabled = ' disabled="disabled"';
      }
      $js = 'window.location="index.php?f=show&amp;o=slave&amp;t=change_master&amp;node_id=' . $node['node_id'] . '";';
      ?>
      <input type="button" value="Change Master" title="Slave can only be rebuilt when stopped." <?php print $disabled; ?> onClick='<?php print $js; ?>'>

      &nbsp;

      <?php
      // This is not a Slave yet (aSlaveStatus == NULL)
      if ( count($aSlaveStatus) == 0 ) {
        $js = 'window.location="index.php?f=make&amp;o=slave&amp;node_id=' . $node['node_id'] . '";';
        ?>
        <input type="button" value="Make Slave" onClick='<?php print $js; ?>'>
        <?php
      }
      ?>
      </td>
    </tr>
    <?php
  }
  ?>
</table>

<?php
closeRepositoryDatabase($dbh);
?>
